% Created as part of TACTICS_v3.0'
% TACTICS Toolbox has been written by Raz Shimoni as a sole and exclusive programmer.
% TACTICS is a Matlab toolbox for High Content Analysis (HCA) of fluorescence tagged proteins organization within tracked cells. It designed to provide a platform for analysis of multi-Channel single-Cell Tracking and quantification of imaged lymphocytes.
% TACTICS available, in executable form, free for academic research use distributed under BSD License.
% IN ADDITION, SINCE TACTICS USE THIRD OPEN-CODE LIBRARY (I.E TRACKING ALGORITHEMS, FILTERS, GUI TOOLS, ETC) APPLICABLE ACKNOLEDMENTS HAVE TO BE SAVED TO ITS AUTHORS.
% ----------------------------------------------------------------------------------------------------------
% Copyright (c) 2010-2014, Raz Shimoni
% All rights reserved.
% Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
% Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
% Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
%IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% ----------------------------------------------------------------------------------------------------------
% NOTES-
% Although TACTICS is free it does require Matlab commercial license.
% We do not expect co-authorship for any use of TACTICS. However, we would appreciate if TACTICS would be mentioned in the acknowledgments when it used for publications and/or including the next citation: [enter our Bioinformatics]
% We are looking for collaborations and wiling to setup new components customized by the requirements in exchange to co-authorship.
%  Support and feedbacks
% TACTICS is supported trough Matlab file exchange forums or contact us directly. Updates are expected regularly. We are happy to accept any suggestions to improve the automation capability and the quality of the analysis.
% If other programmer modify or add new capabilities to TACTICS, only the new prospective code should credited to the corresponding programmer.
% To sharp the points above, if a developer made X contribution to TACTICS (where X stands for a specific function, modification, new code, new module, new tool, etc), a statement such as the following shall be provided:
% "Using TACTICS as a platform, I programmed/wrote/coded/etc X in order to..."
% Thus, the credit shall be towards the X contribution but not towards TACTICS.
% For more information please read my thesis:
% Centre for Micro-Photonics (CMP)
% The Faculty of Engineering and Industrial Sciences (FEIS)
% Swinburne University of Technology, Melbourne, Australia
% URL: http://www.swinburne.edu.au/engineering/cmp/
% or contact me through: raz.shimoni@gmail.com
% Note for developers- Future versions will include better structure and documentation.
%% ________________TACTICS Code starts here:________________
load FIRST_PARENTAL_Radius
Radius_dist=hist(FIRST_PARENTAL_Radius,1:max(FIRST_PARENTAL_Radius));
load FIRST_PARENTAL_TOTAL_INTENSITY
INTENSITY_dist_non_clustered=hist(FIRST_PARENTAL_TOTAL_INTENSITY-100000 ,1:max(FIRST_PARENTAL_TOTAL_INTENSITY));
INTENSITY_dist_clustered=hist(FIRST_PARENTAL_TOTAL_INTENSITY-200000,1:max(FIRST_PARENTAL_TOTAL_INTENSITY));
Xlim=201;
Ylim=201;
C=1.1;
s1 =0.12;
s2 =0.12;
xCentroid =101;% Xlim/2;
matrix=zeros(Xlim,Ylim);
im_sz=size(matrix);
tetha= -pi/2:(pi/200):0;
handles.tetha=-tetha;
RatIO=1:0.05:1.5
[Y] = meshgrid(RatIO,1:100); X=meshgrid(1:100,1:11);X=X';  XY=round(X.*Y) ;XY= XY(:)
%
hhh=timebar_TACWrapper( 'Please wait....');
set(hhh,'color','w');
% %
for nnn=1:1100
    timebar_TACWrapper(hhh,nnn/1100)
    Sim_Ratio =   Y(nnn) ;
    R=gendist(Radius_dist,1,1);
    total_intensity_non_clustered =  gendist(INTENSITY_dist_non_clustered,1,1);
    total_intensity_clustered =  gendist(INTENSITY_dist_clustered,1,1);
    vec_R(nnn)=R;
    a=rand(1,79);
    [~,c]=sort(a);
    Val=c(1)+20;
    %    Val=99;
    vec_Val(nnn)=Val;
    tetha2=handles.tetha(Val)   ;
    Perlin_matrix_non_clustered=Perlin(size(matrix),8,8);
    r=R*((1 + 0.5*cos(tetha2) * (3 -  cos(tetha2)^2 )).^ (-1/3)) ;
    % Law of cosines
    d=sqrt(2*r^2-2*r^2*cos(pi-2*tetha2));
    if Val>61
        d=d*(1+(Val-61)/100);
    end
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    yCentroid = 101 -d/2; yCentroid=ceil(yCentroid);
    matrix3= get_oval_cell(r,xCentroid,yCentroid,matrix,C,s1,s2, -1)  ;
    yCentroid = 101 +d/2; yCentroid=ceil(yCentroid);
    matrix6= get_oval_cell(r,xCentroid,yCentroid,matrix,C,s1,s2, +1);
    %    sum(sum( matrix6))
    %     sum( sum(matrix3))
    %     pause
    input_number_spots_D1= ceil(rand(1)*100);
    while input_number_spots_D1<=20
        input_number_spots_D1=ceil(rand(1)*100);
    end
    input_number_spots_D2=  ceil(input_number_spots_D1*Sim_Ratio);
    BW=matrix3+matrix6;
    BW=BW./BW;
    BW(isnan(BW))=0;
    Segment=rot90(BW);
    BW=rot90(rot90(rot90(SCD_SIM_SPLIT(rot90(BW),[] ,Val  )))) ;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Centroid = [xCentroid  xCentroid+d/2] ;
    matrix_gaussian1 = customgauss(size(matrix3), r, 1 , Centroid);
    Centroid = [xCentroid  xCentroid-d/2];
    matrix_gaussian2 = customgauss(size(matrix3), r, 1 , Centroid);
    matrix_gaussian1(isnan(matrix_gaussian1))=0;matrix_gaussian2(isnan(matrix_gaussian2))=0;
    rot_matrix_gaussian=max(rot90(matrix_gaussian1),rot90(matrix_gaussian2));
    rot_matrix_gaussian=Segment.* rot_matrix_gaussian;
    matrix7_non_clustered= rot_matrix_gaussian.*Perlin_matrix_non_clustered ;
    matrix7_non_clustered=  (255*(matrix7_non_clustered./max(max(matrix7_non_clustered))));
    h=fspecial( 'disk' );
    %  blur:
    matrix9_non_clustered =imfilter(matrix7_non_clustered,h,'replicate');
    %     centrlize intensity histogram:
    matrix9_non_clustered =10*(matrix9_non_clustered).^0.5;
    matrix9_non_clustered =real(  matrix9_non_clustered );
    matrix9_non_clustered= matrix9_non_clustered./max(max( matrix9_non_clustered));
    matrix9_non_clustered=matrix9_non_clustered-0.1;
    %     noise:
    matrix9_non_clustered=imnoise(matrix9_non_clustered,'gaussian');
    matrix9_non_clustered=imnoise(matrix9_non_clustered,'poisson');
    final_intensity=total_intensity_non_clustered*((0.5*Val+100)/100);
    matrix9_non_clustered=matrix9_non_clustered*(final_intensity/sum(sum(matrix9_non_clustered))) ;
    matrix9_non_clustered= uint8(255*(matrix9_non_clustered./max(max( matrix9_non_clustered))));
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %     simulation of natural variance in minor, i.e. resulated by
    %     out-of focus
    matrix10_non_clustered=double(matrix9_non_clustered).*double(Segment);
    Sim_Ratio_NORM=(Sim_Ratio-1)/(Sim_Ratio+1);
    BW_BW=rot90(BW);
    BW2= BW_BW ;      BW1= BW_BW ;
    BW1(BW1>0)=0;BW1(BW1<0)=1;BW1=imfill(BW1);  Ind1=find(ismember(BW1,1));
    BW2(BW2<0)=0;BW2(BW2>0)=1;BW2=imfill(BW2);  Ind2=find(ismember(BW2,1));
    Left=sum(matrix10_non_clustered(Ind1))/length(Ind1);
    Right=sum(matrix10_non_clustered(Ind2))/length(Ind2);
    old_ratio=  (Left/Right) ;
    matrix10_non_clustered(Ind1)= matrix10_non_clustered(Ind1)/old_ratio;
    new_minor_ratio =  0+ 0.01.*randn(1);
    new_ratio =(1-new_minor_ratio)/(1+new_minor_ratio);
    matrix10_non_clustered(Ind1)= matrix10_non_clustered(Ind1)/new_ratio;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %     ONE CELL AS MORE FLUORESENCE IN COMPARE TO THE OTHER:
    BW2= abs(BW_BW) ;      BW1=  abs(BW_BW) ;
    BW1(BW1~=1)=0;  BW1=imfill(BW1);  Ind1=find(ismember(BW1,1));
    BW2(BW2~=2)=0;   BW2=imfill(BW2);  Ind2=find(ismember(BW2,2));
    Area1=length(Ind1);    Area2=length(Ind2);
    D1=sum(matrix10_non_clustered(Ind1))/Area1 ;
    D2=sum(matrix10_non_clustered(Ind2))/Area2 ;
    old_ratio=  (D1/D2)  ;
    matrix10_non_clustered(Ind1)= matrix10_non_clustered(Ind1)/old_ratio;
    new_minor_ratio =  Sim_Ratio_NORM+ 0.01.*randn(1);
    new_ratio =(1/Area1-new_minor_ratio/Area2)/(1/Area1+new_minor_ratio/Area2);
    matrix10_non_clustered(Ind1)= matrix10_non_clustered(Ind1)/new_ratio;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %     simulation of "bad data"
    if rand(1)<0.1
        matrix10_non_clustered=bad_data_function( matrix10_non_clustered, BW);
    end
    stack_non_clustered(nnn).cdata=matrix10_non_clustered ;
    stack_BW(nnn).cdata=BW;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
    BW1=abs(BW);    BW1(BW1==2)=0; BW1=imfill(BW1);
    BW2=abs(BW);    BW2(BW2==1)=0; BW2=BW2/2; BW2=imfill(BW2);
    Ind1=find(ismember(BW1,1))  ;
    Ind2=find(ismember(BW2 ,1))   ;
    BW=rot90(rot90(BW));
    BW1=abs(BW);    BW1(BW1==2)=0; BW1=imfill(BW1);
    BW2=abs(BW);    BW2(BW2==1)=0; BW2=BW2/2; BW2=imfill(BW2);
    Ind1=find(ismember(BW1,1))  ;
    Ind2=find(ismember(BW2 ,1))   ;
    number_spots_D1=input_number_spots_D1 ;
    number_spots_D2=input_number_spots_D2 ;
    for iiii=1:number_spots_D1
        a=rand(1,length(Ind1)); [~,c]=sort(a);
        spot_data1_XY(iiii) =Ind1(c(1)) ;
    end
    for iiii=1:number_spots_D2
        a=rand(1,length(Ind2)); [~,c]=sort(a);
        spot_data2_XY(iiii) =Ind2(c(1)) ;
    end
    [spot_data1.Xcent,spot_data1.Ycent] = ind2sub(im_sz,spot_data1_XY);
    [spot_data2.Xcent,spot_data2.Ycent] = ind2sub(im_sz,spot_data2_XY);
    Perlin_matrix1=spotmaker(size(matrix),number_spots_D1,spot_data1);
    Perlin_matrix2=spotmaker(size(matrix),number_spots_D2,spot_data2);
    Perlin_matrix1=spotmaker(size(matrix),number_spots_D1,spot_data1);
    Perlin_matrix2=spotmaker(size(matrix),number_spots_D2,spot_data2);
    %     rot_matrix_gaussian=max(rot90(matrix_gaussian1),rot90(matrix_gaussian2));
    matrix7_clustered= rot_matrix_gaussian.*Perlin_matrix2+rot_matrix_gaussian.*Perlin_matrix1;
    matrix7_clustered=  (255*(matrix7_clustered./max(max(matrix7_clustered)))); 
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %     simulation of natural variance in minor :
    matrix10_clustered=double(matrix7_clustered).*double(Segment);
    Sim_Ratio_NORM=(Sim_Ratio-1)/(Sim_Ratio+1);
    BW_BW=rot90(BW);
    BW2= BW_BW ;      BW1= BW_BW ;
    BW1(BW1>0)=0;BW1(BW1<0)=1;BW1=imfill(BW1);  Ind1=find(ismember(BW1,1));
    BW2(BW2<0)=0;BW2(BW2>0)=1;BW2=imfill(BW2);  Ind2=find(ismember(BW2,1));
    Left=sum(matrix10_clustered(Ind1))/length(Ind1);
    Right=sum(matrix10_clustered(Ind2))/length(Ind2);
    old_ratio=  (Left/Right) ;
    matrix10_clustered(Ind1)= matrix10_clustered(Ind1)/old_ratio;
    new_minor_ratio =  0+ 0.03.*randn(1);
    new_ratio =(1-new_minor_ratio)/(1+new_minor_ratio);
    matrix10_clustered(Ind1)= matrix10_clustered(Ind1)/new_ratio;
    BW2= abs(BW_BW) ;      BW1=  abs(BW_BW) ;
    BW1(BW1~=1)=0;  BW1=imfill(BW1);  Ind1=find(ismember(BW1,1));
    BW2(BW2~=2)=0;   BW2=imfill(BW2);  Ind2=find(ismember(BW2,2));
    Area1=length(Ind1);    Area2=length(Ind2);
    D1=sum(matrix10_clustered(Ind1))/Area1 ;
    D2=sum(matrix10_clustered(Ind2))/Area2 ;
    old_ratio=  (D1/D2)  ;
    matrix10_clustered(Ind1)= matrix10_clustered(Ind1)/old_ratio;
    new_minor_ratio =  Sim_Ratio_NORM+ 0.02.*randn(1);
    new_ratio =(1/Area1-new_minor_ratio/Area2)/(1/Area1+new_minor_ratio/Area2);
    matrix10_clustered(Ind1)= matrix10_clustered(Ind1)/new_ratio;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %  Adding blur :
    h=fspecial( 'gaussian' );
    matrix9_clustered =imfilter(matrix10_clustered,h,'replicate');
    % centrelized intensity histogram to the center to avoid over-saturation
    matrix9_clustered =10*(matrix9_clustered).^0.3;
    matrix9_clustered =real(  matrix9_clustered );
    matrix9_clustered= matrix9_clustered./max(max( matrix9_clustered));
    %     Adding basal fluoresence (i.e. autofluoresence)
    matrix9_clustered=matrix9_clustered+0.01;
    %     Adding noise:
    matrix9_clustered=imnoise(matrix9_clustered,'gaussian');
    matrix9_clustered=imnoise(matrix9_clustered,'poisson');
    %     simulation of "bad data"
    %     centrelized total intensity (to present real sorted population, that usually has some variance in expression)
    final_intensity=total_intensity_clustered*((0.5*Val+100)/100);
    matrix9_clustered=matrix9_clustered*(final_intensity/sum(sum(matrix9_clustered)))   ;
    matrix9_clustered=  (255*(matrix9_clustered./max(max(matrix9_clustered))));
    if rand(1)<0.1
        matrix9_clustered=bad_data_function(matrix9_clustered, BW);
    end
    stack_clustered(nnn).cdata=matrix9_clustered ;
    spots_D1(nnn)=input_number_spots_D1 ;
    spots_D2(nnn) =input_number_spots_D2 ;
end
close(h)
msgbox('ready')
